import pyqtgraph as pg
from IPython import embed
import numpy as np

from PyQt6.QtCore import QTimer
from pyrelacs.dataio.circbuffer import CircBuffer
from pyrelacs.util.logging import config_logging

log = config_logging()


class Continously:
    def __init__(self, figure: pg.GraphicsLayoutWidget, buffer: CircBuffer):
        self.figure = figure
        self.buffer = buffer

    def plot_daq(self, *args, **kwargs):
        self.figure.setBackground("w")
        self.daq_plot = self.figure.addPlot(row=0, col=0)
        pen = pg.mkPen("red")
        self.time = np.arange(self.buffer.size) / self.buffer.samplerate
        self.data = np.ones(self.buffer.size)
        log.debug(self.data.size)
        log.debug(self.time.size)
        self.line = self.daq_plot.plot(
            self.time, self.data, pen=pen, setCliptoView=True
        )
        # self.line.setXRrange(np.arange(0, 10, 1 / self.buffer.samplerate))

        self.item = 0
        self.timer = QTimer()
        self.timer.setInterval(1)
        self.timer.timeout.connect(self.update_plot)
        self.timer.start()

    def update_plot(self):
        if self.buffer.totalcount() > 100:
            if self.buffer.write_index() > self.item:
                # self.time = self.time[1:]
                # self.time.append(self.time[-1] + 1)
                # self.data = self.data[1:]
                item = self.buffer.get_all()
                t = np.arange(item.shape[0]) / self.buffer.samplerate
                # self.data.append(item)
                self.line.setData(t, item)
                self.item += 1
            else:
                pass
